local mod	= DBM:NewMod("Patchwerk", "DBM-Naxx", 2)
local L		= mod:GetLocalizedStrings()

mod:SetRevision(("$Revision: 22 $"):sub(12, -3))
mod:SetCreatureID(16028)
mod:SetModelID(16174)
mod:RegisterCombat("combat")

mod:EnableModel()

mod:RegisterEvents(
	"CHAT_MSG_MONSTER_YELL"
)

local enrageTimer	= mod:NewBerserkTimer(360)
local timerAchieve	= mod:NewAchievementTimer(180, 1857, "TimerSpeedKill")

function mod:OnCombatStart(delay)
	enrageTimer:Start(-delay)
	timerAchieve:Start(-delay)
end

--Secondary pull trigger, so we can detect combat when he's pulled while already in combat (which is about 99% of time)
function mod:CHAT_MSG_MONSTER_YELL(msg)
	if (msg == L.yell1 or msg == L.yell2) and not self:IsInCombat() then
		DBM:StartCombat(self, 0)
	end
end
